/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.msp.showpetinfo
 *  fire.pb.Pet
 *  fire.pb.Petskill
 *  fire.pb.buff.BuffRoleImpl
 *  fire.pb.buff.Module
 *  fire.pb.buff.continual.ConstantlyBuff
 *  fire.pb.course.CourseManager
 *  fire.pb.effect.PetImpl
 *  fire.pb.event.Event
 *  fire.pb.event.PetSkillChangeEvent
 *  fire.pb.event.Poster
 *  fire.pb.exception.NoSuchUniquePetException
 *  fire.pb.item.ItemBase
 *  fire.pb.item.Module
 *  fire.pb.item.PETEQUIP
 *  fire.pb.item.PETEquipItem
 *  fire.pb.item.Pack
 *  fire.pb.item.SPetSkillSuccessConfig
 *  fire.pb.main.ConfigManager
 *  fire.pb.ranklist.proc.PRankInsertPet
 *  fire.pb.ranklist.proc.PRoleZongheRankProc
 *  fire.pb.ranklist.proc.RankListManager
 *  fire.pb.skill.Module
 *  fire.pb.skill.SPetSkillupgrade
 *  fire.pb.skill.SkillPet
 *  fire.pb.skill.fight.FightSkillConfig
 *  fire.pb.util.StringConstant
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.BasicFightProperties
 *  xbean.Item
 *  xbean.PetInfo
 *  xbean.PetSkill
 *  xbean.Pod
 *  xtable.Properties
 */
package fire.pb.pet;

import fire.msp.showpetinfo;
import fire.pb.Petskill;
import fire.pb.buff.BuffRoleImpl;
import fire.pb.buff.continual.ConstantlyBuff;
import fire.pb.course.CourseManager;
import fire.pb.effect.PetImpl;
import fire.pb.event.Event;
import fire.pb.event.PetSkillChangeEvent;
import fire.pb.event.Poster;
import fire.pb.exception.NoSuchUniquePetException;
import fire.pb.item.ItemBase;
import fire.pb.item.PETEQUIP;
import fire.pb.item.PETEquipItem;
import fire.pb.item.Pack;
import fire.pb.item.SPetSkillSuccessConfig;
import fire.pb.main.ConfigManager;
import fire.pb.pet.CalcPetAttr;
import fire.pb.pet.DiscardPetImpl;
import fire.pb.pet.IUniquePetWrap;
import fire.pb.pet.Module;
import fire.pb.pet.PetAttr;
import fire.pb.pet.PetColumn;
import fire.pb.pet.PetManager;
import fire.pb.pet.SRefreshPetInfo;
import fire.pb.pet.SRefreshPetInternal;
import fire.pb.pet.SRefreshPetScore;
import fire.pb.pet.SRefreshPetSkill;
import fire.pb.pet.UniquePetImpl;
import fire.pb.ranklist.proc.PRankInsertPet;
import fire.pb.ranklist.proc.PRoleZongheRankProc;
import fire.pb.ranklist.proc.RankListManager;
import fire.pb.skill.SPetSkillupgrade;
import fire.pb.skill.SkillPet;
import fire.pb.skill.fight.FightSkillConfig;
import fire.pb.util.StringConstant;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.BasicFightProperties;
import xbean.Item;
import xbean.PetInfo;
import xbean.PetSkill;
import xbean.Pod;
import xtable.Properties;

public class Pet {
    public static int PET_LOCK_ERROR_MSG = 142665;
    private final long roleId;
    private final int columnType;
    private final PetInfo petInfo;
    private final PetAttr petAttr;

    public static Pet getPet(PetInfo petInfo) {
        if (petInfo == null) {
            return null;
        }
        return new Pet(-1L, -1, petInfo, true);
    }

    public static String getColorString(int color) {
        return "fffcfbfb";
    }

    public static Pet getPet(long roleId, PetColumn petColumn, int petKey, boolean readOnly) {
        try {
            if (petColumn == null) {
                return null;
            }
            PetInfo petInfo = petColumn.getPetInfo(petKey);
            if (petInfo == null) {
                return null;
            }
            return new Pet(roleId, petColumn.getPetColumnType(), petInfo, readOnly);
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static Pet getPet(long roleId, int petColumnType, int petKey, boolean readOnly) {
        try {
            PetColumn petColumn = new PetColumn(roleId, petColumnType, readOnly);
            PetInfo petInfo = petColumn.getPetInfo(petKey);
            if (petInfo == null) {
                return null;
            }
            return new Pet(roleId, petColumnType, petInfo, readOnly);
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static Pet getPet(long uniquePetId, boolean readOnly) {
        IUniquePetWrap uniquePetWrap = null;
        try {
            uniquePetWrap = new UniquePetImpl(uniquePetId, readOnly);
        }
        catch (NoSuchUniquePetException e) {
            try {
                uniquePetWrap = new DiscardPetImpl(uniquePetId, readOnly);
            }
            catch (NoSuchUniquePetException e1) {
                return null;
            }
        }
        return uniquePetWrap.getPetInfo();
    }

    public Pet(long roleId, int columnType, PetInfo petInfo, boolean readonly) {
        this.roleId = roleId;
        this.columnType = columnType;
        this.petInfo = petInfo;
        if (petInfo == null) {
            throw new IllegalArgumentException("ERROR: petInfo == null roleId = " + roleId);
        }
        this.petAttr = Module.getInstance().getPetManager().getAttr(petInfo.getId());
        if (this.petAttr == null) {
            throw new IllegalArgumentException("ERROR: petAttr == null petId = " + petInfo.getId() + " roleId = " + roleId);
        }
    }

    public long getRoleId() {
        return this.roleId;
    }

    public int getColumnType() {
        return this.columnType;
    }

    public int getPetkey() {
        return this.petInfo.getKey();
    }

    public PetInfo getPetInfo() {
        return this.petInfo;
    }

    public PetInfo copyPetInfoBean() {
        return this.petInfo.copy();
    }

    public PetAttr getPetAttr() {
        return this.petAttr;
    }

    public int petSkillsGrid() {
        return 17;
    }

    public int getSkillMaxNum() {
        return this.petSkillsGrid();
    }

    public static int getClour(int starId) {
        return 1;
    }

    public int getTreasure() {
        return this.petInfo.getTreasure();
    }

    public int getBaseId() {
        return this.petInfo.getId();
    }

    public String getName() {
        return this.petInfo.getName();
    }

    public void setName(String newname) {
        this.petInfo.setName(newname);
    }

    public short getLevel() {
        return (short)this.petInfo.getLevel();
    }

    public void setLevel(short level) {
        this.petInfo.setLevel((int)level);
    }

    public int getUseLevel() {
        return this.petAttr.getUselevel();
    }

    public int getTakeLevel() {
        return this.petAttr.getTakelevel();
    }

    public int getSize() {
        return 0;
    }

    public int getColor() {
        return Pet.getClour(1);
    }

    public String getColorString() {
        return Pet.getColorString(this.getColor());
    }

    public int getPoint() {
        return this.petInfo.getPoint();
    }

    public void setPoint(int point) {
        this.petInfo.setPoint(point);
    }

    public int getHp() {
        return this.petInfo.getHp();
    }

    public void setHp(int hp) {
        this.petInfo.setHp(hp);
    }

    public int getMp() {
        return this.petInfo.getMp();
    }

    public void setMp(int mp) {
        this.petInfo.setMp(mp);
    }

    public int getGrowrate() {
        return this.petInfo.getGrowrate();
    }

    public int getMaxLife() {
        return 20000;
    }

    public int getLife() {
        return this.petInfo.getLife();
    }

    public void setLife(int life) {
        this.petInfo.setLife(life);
    }

    public int addLife(int addlife) {
        if (Module.getInstance().getPetManager().isPetLifeForever(this.getPetAttr().getId())) {
            return this.getLife();
        }
        this.setLife(Math.max(0, Math.min(20000, this.getLife() + addlife)));
        return this.getLife();
    }

    public long getExp() {
        return this.petInfo.getExp();
    }

    public void setExp(long exp) {
        this.petInfo.setExp(exp);
    }

    public int getKind() {
        return this.petInfo.getKind();
    }

    public BasicFightProperties getInitBfp() {
        return this.petInfo.getInitbfp();
    }

    public BasicFightProperties getBfp() {
        return this.petInfo.getBfp();
    }

    public Map<Integer, Float> getEffects() {
        return this.petInfo.getEffects();
    }

    public Map<Integer, Float> getFinalAttrs() {
        return this.petInfo.getFinalattrs();
    }

    public boolean isBind() {
        return this.petInfo.getIsbinded();
    }

    public void setBind(boolean isbind) {
        this.petInfo.setIsbinded(isbind);
    }

    public long getUniqueId() {
        return this.petInfo.getUniqid();
    }

    public long isLocked() {
        if (this.petInfo.getIslocked()) {
            if (this.petInfo.getTimeout() > 0L) {
                if (this.petInfo.getTimeout() < System.currentTimeMillis()) {
                    this.petInfo.setTimeout(0L);
                    return 0L;
                }
                return this.petInfo.getTimeout();
            }
            return 0L;
        }
        return -1L;
    }

    public boolean isMarketFreeze() {
        long t = this.petInfo.getMarketfreezeexpire();
        return t > 0L && t > System.currentTimeMillis();
    }

    public void setMarketFreezeExpire(long expireTime) {
        this.petInfo.setMarketfreezeexpire(expireTime);
    }

    public List<PetSkill> getBattleskills() {
        return this.petInfo.getSkills();
    }

    public List<Integer> getEquiplist() {
        return this.petInfo.getEquiplist();
    }

    public List<Integer> getBattleskillIds() {
        LinkedList<Integer> skillIds = new LinkedList<Integer>();
        for (PetSkill skill : this.getBattleskills()) {
            skillIds.add(skill.getSkillid());
        }
        return skillIds;
    }

    public boolean hasSkill(int skillId) {
        List<PetSkill> skills = this.getBattleskills();
        for (PetSkill skill : skills) {
            if (skill.getSkillid() != skillId) continue;
            return true;
        }
        return false;
    }

    public int getSkillLevel(int skillId) {
        List<PetSkill> skills = this.getBattleskills();
        SPetSkillupgrade config = PetManager.getInstance().getSkillUpGrade(skillId);
        if (config == null) {
            return 0;
        }
        int flag = config.getSign();
        for (PetSkill skill : skills) {
            SPetSkillupgrade temp = PetManager.getInstance().getSkillUpGrade(skill.getSkillid());
            if (temp == null || temp.getSign() != flag) continue;
            return temp.getSkilllevel();
        }
        return 0;
    }

    public boolean hasAnySkill(int skillId) {
        List<PetSkill> skills = this.getBattleskills();
        SPetSkillupgrade config = PetManager.getInstance().getSkillUpGrade(skillId);
        if (config == null) {
            return false;
        }
        int flag = config.getSign();
        for (PetSkill skill : skills) {
            SPetSkillupgrade temp = PetManager.getInstance().getSkillUpGrade(skill.getSkillid());
            if (temp == null || temp.getSign() != flag) continue;
            return true;
        }
        return false;
    }

    public int getAutoSkillId() {
        List<PetSkill> skills = this.getBattleskills();
        for (PetSkill skill : skills) {
            FightSkillConfig sconf = fire.pb.skill.Module.getInstance().getFightSkillConfig(skill.getSkillid());
            if (sconf == null || sconf.getAddautoSkill() != 1) continue;
            return skill.getSkillid();
        }
        return -1;
    }

    public boolean addEquip(PETEquipItem equip, int EquipType, long petkey1) {
        List<Integer> Equips = this.getEquiplist();
        Equips.set(EquipType - 1, equip.getItemId());
        int petkey = (int)petkey1;
        PetImpl epet = new PetImpl(this.roleId, petkey);
        for (Map.Entry entry : equip.getEquipAttr().getAttr().entrySet()) {
            System.out.println(entry.getKey() + "  ---  " + entry.getValue());
            int id = (Integer)entry.getKey();
            if (--id == 1440) {
                epet.addBornattackApt(((Integer)entry.getValue()).intValue());
            }
            if (id == 1450) {
                epet.addBorndefendApt(((Integer)entry.getValue()).intValue());
            }
            if (id == 1460) {
                epet.addBornphyforceApt(((Integer)entry.getValue()).intValue());
            }
            if (id == 1470) {
                epet.addBornmagicApt(((Integer)entry.getValue()).intValue());
            }
            if (id == 1480) {
                epet.addBornspeedApt(((Integer)entry.getValue()).intValue());
            }
            if (id != 1490) continue;
            epet.addBorndodgeApt(((Integer)entry.getValue()).intValue());
        }
        PetColumn petCol = new PetColumn(this.roleId, 1, false);
        Pet pet = petCol.getPet(petkey);
        SRefreshPetInfo refresh = new SRefreshPetInfo(pet.getProtocolPet());
        Procedure.psendWhileCommit((long)this.roleId, (Protocol)refresh);
        return true;
    }

    public boolean biEquip(Item item, int EquipType, long petkey1) {
        int petkey = (int)petkey1;
        ItemBase itemBase = fire.pb.item.Module.getInstance().getItemManager().toItemBase(item);
        PETEquipItem itemx = (PETEquipItem)itemBase;
        PetImpl epet = new PetImpl(this.roleId, petkey);
        for (Map.Entry entry : itemx.getEquipAttr().getAttr().entrySet()) {
            int id = (Integer)entry.getKey();
            if (--id == 1440) {
                epet.addBornattackApt(-((Integer)entry.getValue()).intValue());
            }
            if (id == 1450) {
                epet.addBorndefendApt(-((Integer)entry.getValue()).intValue());
            }
            if (id == 1460) {
                epet.addBornphyforceApt(-((Integer)entry.getValue()).intValue());
            }
            if (id == 1470) {
                epet.addBornmagicApt(-((Integer)entry.getValue()).intValue());
            }
            if (id == 1480) {
                epet.addBornspeedApt(-((Integer)entry.getValue()).intValue());
            }
            if (id != 1490) continue;
            epet.addBorndodgeApt(-((Integer)entry.getValue()).intValue());
        }
        PetColumn petCol = new PetColumn(this.roleId, 1, false);
        Pet pet = petCol.getPet(petkey);
        SRefreshPetInfo refresh = new SRefreshPetInfo(pet.getProtocolPet());
        Procedure.psendWhileCommit((long)this.roleId, (Protocol)refresh);
        return true;
    }

    public boolean delEquip(int EquipId, int EquipType, int petId) {
        System.out.println(petId);
        List<Integer> Equips = this.getEquiplist();
        LinkedList<Integer> integers = new LinkedList<Integer>();
        long petkey11 = this.roleId + (long)petId;
        PETEQUIP petequip = new PETEQUIP(this.roleId, false, petkey11);
        Pack bag = (Pack)fire.pb.item.Module.getInstance().getItemMaps(this.roleId, 1, false);
        int posinpack = 0;
        for (ItemBase itemBase : petequip) {
            if (!(itemBase instanceof PETEquipItem)) continue;
            integers.add(itemBase.getKey());
            petequip.onUnequip((PETEquipItem)itemBase);
            int typeid = ((PETEquipItem)itemBase).getEquipType() >> 4 & 0xF;
            Equips.remove(typeid - 1);
        }
        for (Integer integer : integers) {
            ItemBase bi = petequip.TransOut(integer.intValue(), -1, "卸下装备");
            if (bi == null) {
                return false;
            }
            ArrayList freepos = bag.getFreepos();
            if (freepos.size() <= 0) {
                return false;
            }
            posinpack = (Integer)freepos.get(0);
            ItemBase dstitem = posinpack != -1 ? bag.getItemByPos(posinpack) : null;
            if (dstitem != null) {
                return false;
            }
            if (!bag.TransIn(bi, posinpack)) {
                return false;
            }
            if (!(bi instanceof PETEquipItem)) continue;
            petequip.onUnequip((PETEquipItem)bi);
        }
        Equips.clear();
        PetColumn petCol = new PetColumn(this.roleId, 1, false);
        Pet pet = petCol.getPet(petId);
        SRefreshPetInfo refresh = new SRefreshPetInfo(pet.getProtocolPet());
        Procedure.psendWhileCommit((long)this.roleId, (Protocol)refresh);
        return true;
    }

    public boolean addSkill(int skillId, long expireTime, int skillExp, int skillType) {
        List<PetSkill> skills;
        int maxSkillNum = this.getSkillMaxNum();
        if (skillType != 2) {
            --maxSkillNum;
        }
        if ((skills = this.getBattleskills()).size() >= maxSkillNum) {
            return false;
        }
        if (this.hasAnySkill(skillId)) {
            return false;
        }
        PetSkill newSkill = Pod.newPetSkill();
        newSkill.setSkillid(skillId);
        newSkill.setSkilltype(skillType);
        skills.add(newSkill);
        this.updatePetScoreWhileChange();
        this.updatePetSkillChange();
        if (this.petInfo.getLevel() >= 60) {
            CourseManager.achieveCourse((long)this.roleId, (int)21, (int)skillId, (int)0);
        }
        CourseManager.checkAchieveCourse((long)this.roleId, (int)31, (int)this.getPetInfo().getPetscore());
        return true;
    }

    public int insertSkill(int index, int skillId, long expiretime, int skillType) {
        int maxSkillNum = this.getSkillMaxNum();
        List<PetSkill> skills = this.getBattleskills();
        int size = skills.size();
        if (size > maxSkillNum) {
            return -1;
        }
        if (index + 1 > size) {
            return -2;
        }
        for (PetSkill skill : skills) {
            if (skill.getSkillid() != skillId) continue;
            return -3;
        }
        PetSkill newSkill = Pod.newPetSkill();
        newSkill.setSkillid(skillId);
        newSkill.setSkilltype(skillType);
        PetSkill oldSkill = skills.set(index, newSkill);
        this.updatePetScoreWhileChange();
        this.updatePetSkillChange();
        if (this.petInfo.getLevel() >= 60) {
            CourseManager.achieveCourse((long)this.roleId, (int)21, (int)skillId, (int)0);
        }
        CourseManager.checkAchieveCourse((long)this.roleId, (int)31, (int)this.getPetInfo().getPetscore());
        return oldSkill.getSkillid();
    }

    public boolean removeSkillById(int skillId) {
        List<PetSkill> skills = this.getBattleskills();
        Iterator<PetSkill> it = skills.iterator();
        while (it.hasNext()) {
            PetSkill skill = it.next();
            if (skill.getSkillid() != skillId) continue;
            it.remove();
            this.updatePetScoreWhileChange();
            this.updatePetSkillChange();
            return true;
        }
        return false;
    }

    public static boolean isInBattle(long roleId, int petKey) {
        PetColumn petCol = new PetColumn(roleId, 1, true);
        if (petCol.getPetInfo(petKey) == null) {
            return false;
        }
        BuffRoleImpl buffRoleImpl = new BuffRoleImpl(roleId, true);
        return !buffRoleImpl.existState(507004) && !buffRoleImpl.existState(507005) && !buffRoleImpl.existState(507027);
    }

    public static int getPetUseLevelConfig(int baseId) {
        PetAttr petAttr = Module.getInstance().getPetManager().getAttr(baseId);
        if (petAttr == null) {
            return 0;
        }
        return petAttr.getUselevel();
    }

    public boolean canLearnNewSkillWhileUpLevel() {
        return Math.random() < (double)this.getLearnSkillProbWhileUpLevel();
    }

    public float getLearnSkillProbWhileUpLevel() {
        int skillNum = this.getBattleskills().size();
        if (skillNum >= this.getSkillMaxNum()) {
            return 0.0f;
        }
        if (skillNum >= 3) {
            return 0.0f;
        }
        TreeMap configMap = ConfigManager.getInstance().getConf(SPetSkillSuccessConfig.class);
        if (configMap == null) {
            return 0.0f;
        }
        SPetSkillSuccessConfig conf = (SPetSkillSuccessConfig)configMap.get(skillNum);
        if (conf == null) {
            return 0.0f;
        }
        float value = conf.getOdds() / conf.getBasenumber();
        return value;
    }

    public int getAttackapt() {
        return this.petInfo.getBornattackapt();
    }

    public int getDefendapt() {
        return this.petInfo.getBorndefendapt();
    }

    public int getPhyforceapt() {
        return this.petInfo.getBornphyforceapt();
    }

    public int getMagicapt() {
        return this.petInfo.getBornmagicapt();
    }

    public int getSpeedapt() {
        return this.petInfo.getBornspeedapt();
    }

    public int getDodgeapt() {
        return this.petInfo.getBorndodgeapt();
    }

    public String getAptitudeStringByAttrType(int attrType, boolean isHaveSuffix) {
        String ret = "";
        switch (attrType) {
            case 1440: {
                ret = StringConstant.ID2String((String)"攻击", (int)262);
                break;
            }
            case 1450: {
                ret = StringConstant.ID2String((String)"防御", (int)264);
                break;
            }
            case 1470: {
                ret = StringConstant.ID2String((String)"法术", (int)263);
                break;
            }
            case 1460: {
                ret = StringConstant.ID2String((String)"体力", (int)260);
                break;
            }
            case 1480: {
                ret = StringConstant.ID2String((String)"速度", (int)261);
            }
        }
        if (isHaveSuffix && ret.length() > 0) {
            ret = String.valueOf(ret) + StringConstant.ID2String((String)"资质", (int)265);
        }
        return ret;
    }

    public PetSkill getShowSkill(List<PetSkill> allSkills) {
        for (PetSkill petSkill : allSkills) {
            if (petSkill == null) continue;
            return petSkill;
        }
        return null;
    }

    ConstantlyBuff getShowSkillBuff(List<PetSkill> allSkills) {
        PetSkill showSkill = this.getShowSkill(allSkills);
        if (showSkill == null) {
            return null;
        }
        long expireTime = -1L;
        if (expireTime <= 0L) {
            return null;
        }
        long now = System.currentTimeMillis();
        if (expireTime < now) {
            return null;
        }
        ConstantlyBuff cBuff = fire.pb.buff.Module.getInstance().createConstantlyBuff(500214);
        cBuff.setTime(expireTime - now);
        return cBuff;
    }

    public fire.pb.Pet getProtocolPet() {
        fire.pb.Pet pet = new fire.pb.Pet();
        pet.id = this.getBaseId();
        pet.ownername = "";
        pet.key = this.petInfo.getKey();
        pet.name = this.getName();
        pet.level = this.getLevel();
        pet.uselevel = Pet.getPetUseLevelConfig(pet.id);
        pet.gengu = 0;
        pet.initbfp.agi = (short)this.getInitBfp().getAgi();
        pet.initbfp.cons = (short)this.getInitBfp().getCons();
        pet.initbfp.endu = (short)this.getInitBfp().getEndu();
        pet.initbfp.iq = (short)this.getInitBfp().getIq();
        pet.initbfp.str = (short)this.getInitBfp().getStr();
        pet.bfp.agi = (short)this.getBfp().getAgi();
        pet.bfp.cons = (short)this.getBfp().getCons();
        pet.bfp.endu = (short)this.getBfp().getEndu();
        pet.bfp.iq = (short)this.getBfp().getIq();
        pet.bfp.str = (short)this.getBfp().getStr();
        pet.point = (short)this.getPetInfo().getPoint();
        pet.autoaddcons = (byte)this.getPetInfo().getAutoaddcons();
        pet.autoaddiq = (byte)this.getPetInfo().getAutoaddiq();
        pet.autoaddstr = (byte)this.getPetInfo().getAutoaddstr();
        pet.autoaddendu = (byte)this.getPetInfo().getAutoaddendu();
        pet.autoaddagi = (byte)this.getPetInfo().getAutoaddagi();
        pet.pointresetcount = (short)this.getPetInfo().getPointresetcount();
        pet.exp = this.getExp();
        pet.attackapt = this.getAttackapt();
        pet.defendapt = this.getDefendapt();
        pet.phyforceapt = this.getPhyforceapt();
        pet.magicapt = this.getMagicapt();
        pet.speedapt = this.getSpeedapt();
        pet.dodgeapt = this.getDodgeapt();
        pet.growrate = this.petInfo.getGrowrate();
        pet.life = this.getLife();
        pet.kind = this.getKind();
        pet.scale = (byte)this.getSize();
        PetImpl petImpl = new PetImpl(this.getPetInfo());
        pet.maxhp = petImpl.getMaxHp();
        pet.maxmp = petImpl.getMaxMp();
        pet.hp = petImpl.getHp();
        pet.mp = petImpl.getMp();
        pet.attack = petImpl.getAttack();
        pet.defend = petImpl.getDefend();
        pet.speed = petImpl.getSpeed();
        pet.magicattack = petImpl.getMagicAttack();
        pet.magicdef = petImpl.getMagicDef();
        pet.nexp = petImpl.getNextExp();
        List<PetSkill> allSkills = this.getBattleskills();
        for (PetSkill skill : allSkills) {
            Petskill petSkill = new Petskill();
            petSkill.skillid = skill.getSkillid();
            petSkill.skillexp = 0;
            petSkill.skilltype = (byte)skill.getSkilltype();
            petSkill.certification = (byte)skill.getCertification();
            pet.skills.add(petSkill);
        }
        if (this.isLocked() != -1L) {
            pet.flag = (byte)(pet.flag | 1);
        }
        if (this.isBind()) {
            pet.flag = (byte)(pet.flag | 2);
        }
        pet.timeout = this.petInfo.getTimeout();
        pet.ownerid = this.petInfo.getOwnerid();
        pet.ownername = Properties.selectRolename((Long)this.petInfo.getOwnerid());
        pet.rank = Pet.getPetRankListByUid(this.petInfo.getUniqid());
        pet.starid = 1;
        pet.practisetimes = 0;
        pet.changegengu = 0;
        pet.skill_grids = this.petSkillsGrid();
        pet.aptaddcount = (byte)this.petInfo.getAptaddcount();
        pet.growrateaddcount = (byte)this.petInfo.getGrowrateaddcount();
        pet.washcount = (short)this.petInfo.getWashcount();
        pet.petscore = this.petInfo.getPetscore();
        pet.petbasescore = this.petInfo.getPetbasescore();
        pet.petdye1 = this.petInfo.getPetdye1();
        pet.petdye2 = this.petInfo.getPetdye2();
        pet.shenshouinccount = this.petInfo.getShenshouinccount();
        pet.marketfreezeexpire = this.petInfo.getMarketfreezeexpire();
        List<PetSkill> allInternals = this.getBattleInternals();
        for (PetSkill internal : allInternals) {
            Petskill petSkill = new Petskill();
            petSkill.skillid = internal.getSkillid();
            petSkill.skillexp = 0;
            petSkill.skilltype = (byte)internal.getSkilltype();
            petSkill.certification = (byte)internal.getCertification();
            pet.internals.add(petSkill);
        }
        pet.Huanhuaid = this.petInfo.getHuanhuaid();
        pet.Equiplist = this.getEquiplist();
        pet.qianye = (byte)this.petInfo.getqianye();
        return pet;
    }

    public static int getPetRankListByUid(long uId) {
        int rankId = RankListManager.getPetRankidByUniqueID((long)uId);
        return rankId < 0 ? 0 : rankId;
    }

    public showpetinfo getShowPetInfo() {
        int skillEffect = 0;
        PetSkill showSkill = this.getShowSkill(this.getBattleskills());
        if (showSkill != null) {
            skillEffect = this.getShowSkillEffect(showSkill.getSkillid());
        }
        return new showpetinfo(this.getBaseId(), (long)this.getPetkey(), this.getName(), this.getColor(), this.getSize(), skillEffect);
    }

    public int getShowSkillEffect(int showskillid) {
        return 0;
    }

    public void fillSRefreshPetSkill(SRefreshPetSkill send) {
        for (PetSkill skill : this.getBattleskills()) {
            Petskill petSkill = new Petskill();
            petSkill.skillexp = 0;
            petSkill.skillid = skill.getSkillid();
            petSkill.skilltype = (byte)skill.getSkilltype();
            petSkill.certification = (byte)skill.getCertification();
            send.skills.add(petSkill);
        }
    }

    public void online() {
        int petHp = this.petInfo.getHp();
        int petMp = this.petInfo.getMp();
        this.offline();
        SkillPet skillPet = new SkillPet(this.petInfo, this.roleId);
        skillPet.addSkillBuffWhileOnline(null);
        if (petHp <= 0) {
            petHp = 1;
        }
        this.petInfo.setHp(petHp);
        this.petInfo.setMp(petMp);
    }

    public void offline() {
        this.petInfo.getBuffpet().getBuffs().clear();
        this.petInfo.getEffects().clear();
        this.petInfo.getFinalattrs().clear();
    }

    public int calculatePetScore() {
        return (int)CalcPetAttr.doCalculate(this);
    }

    public int calculatePetBaseScore() {
        return CalcPetAttr.doBaseScoreCalculate(this);
    }

    public void updatePetScoreWhileChange() {
        int currentScore = this.petInfo.getPetscore();
        int newScore = this.calculatePetScore();
        int baseScore = this.calculatePetBaseScore();
        if (currentScore == newScore) {
            return;
        }
        this.petInfo.setPetscore(newScore);
        this.petInfo.setPetbasescore(baseScore);
        if (newScore - baseScore >= this.petAttr.treasureScore && this.petInfo.getSkills().size() >= this.petAttr.treasureskillnums) {
            this.petInfo.setTreasure(1);
        } else {
            this.petInfo.setTreasure(0);
        }
        SRefreshPetScore send = new SRefreshPetScore();
        send.petkey = this.getPetkey();
        send.petscore = newScore;
        send.petbasescore = baseScore;
        Procedure.psendWhileCommit((long)this.petInfo.getOwnerid(), (Protocol)send);
        Procedure.pexecuteWhileCommit((Procedure)new PRankInsertPet(this.petInfo.getUniqid(), true));
        Procedure.pexecuteWhileCommit((Procedure)new PRoleZongheRankProc(this.petInfo.getOwnerid()));
    }

    public void updatePetSkillChange() {
        if (this.getRoleId() != -1L && this.getPetkey() > 0) {
            Poster.getPoster().dispatchEvent((Event)new PetSkillChangeEvent(this.getRoleId(), this.getPetkey()));
        }
    }

    public List<PetSkill> getBattleInternals() {
        return this.petInfo.getInternals();
    }

    public List<Integer> getBattleInternalIds() {
        LinkedList<Integer> skillIds = new LinkedList<Integer>();
        for (PetSkill skill : this.getBattleInternals()) {
            skillIds.add(skill.getSkillid());
        }
        return skillIds;
    }

    public boolean hasInternal(int skillId) {
        List<PetSkill> skills = this.getBattleInternals();
        for (PetSkill skill : skills) {
            if (skill.getSkillid() != skillId) continue;
            return true;
        }
        return false;
    }

    public int getInternalLevel(int skillId) {
        List<PetSkill> internals = this.getBattleInternals();
        SPetSkillupgrade config = PetManager.getInstance().getSkillUpGrade(skillId);
        if (config == null) {
            return 0;
        }
        int flag = config.getSign();
        for (PetSkill skill : internals) {
            SPetSkillupgrade temp = PetManager.getInstance().getSkillUpGrade(skill.getSkillid());
            if (temp == null || temp.getSign() != flag) continue;
            return temp.getSkilllevel();
        }
        return 0;
    }

    public boolean hasAnyInternal(int skillId) {
        List<PetSkill> internals = this.getBattleInternals();
        SPetSkillupgrade config = PetManager.getInstance().getSkillUpGrade(skillId);
        if (config == null) {
            return false;
        }
        int flag = config.getSign();
        for (PetSkill skill : internals) {
            SPetSkillupgrade temp = PetManager.getInstance().getSkillUpGrade(skill.getSkillid());
            if (temp == null || temp.getSign() != flag) continue;
            return true;
        }
        return false;
    }

    public boolean addInternal(int skillId, long expireTime, int skillExp, int skillType) {
        List<PetSkill> internals;
        int maxSkillNum = this.getInternalMaxNum();
        if (skillType != 2) {
            --maxSkillNum;
        }
        if ((internals = this.getBattleInternals()).size() >= maxSkillNum) {
            return false;
        }
        if (this.hasAnyInternal(skillId)) {
            return false;
        }
        PetSkill newSkill = Pod.newPetSkill();
        newSkill.setSkillid(skillId);
        newSkill.setSkilltype(skillType);
        internals.add(newSkill);
        this.updatePetScoreWhileChange();
        this.updatePetInternalChange();
        return true;
    }

    public int insertInternal(int index, int skillId, long expiretime, int skillType) {
        int maxSkillNum = this.getInternalMaxNum();
        List<PetSkill> internals = this.getBattleInternals();
        int size = internals.size();
        if (size > maxSkillNum) {
            return -1;
        }
        if (index + 1 > size) {
            return -2;
        }
        for (PetSkill skill : internals) {
            if (skill.getSkillid() != skillId) continue;
            return -3;
        }
        PetSkill newSkill = Pod.newPetSkill();
        newSkill.setSkillid(skillId);
        newSkill.setSkilltype(skillType);
        PetSkill oldSkill = internals.set(index, newSkill);
        this.updatePetScoreWhileChange();
        this.updatePetInternalChange();
        return oldSkill.getSkillid();
    }

    public boolean removeInternalById(int skillId) {
        List<PetSkill> internals = this.getBattleInternals();
        Iterator<PetSkill> it = internals.iterator();
        while (it.hasNext()) {
            PetSkill skill = it.next();
            if (skill.getSkillid() != skillId) continue;
            it.remove();
            this.updatePetScoreWhileChange();
            this.updatePetInternalChange();
            return true;
        }
        return false;
    }

    public int petInternalsGrid() {
        return 17;
    }

    public int getInternalMaxNum() {
        return this.petInternalsGrid();
    }

    public void fillSRefreshPetInternal(SRefreshPetInternal send) {
        for (PetSkill skill : this.getBattleInternals()) {
            Petskill petSkill = new Petskill();
            petSkill.skillexp = 0;
            petSkill.skillid = skill.getSkillid();
            petSkill.skilltype = (byte)skill.getSkilltype();
            petSkill.certification = (byte)skill.getCertification();
            send.internals.add(petSkill);
        }
    }

    public void updatePetInternalChange() {
        if (this.getRoleId() != -1L) {
            this.getPetkey();
        }
    }

    public int LevelUpInternal(int Idfrom, int Idto) {
        List<PetSkill> internals = this.getBattleInternals();
        int index = -1;
        int i = 0;
        for (PetSkill skill : internals) {
            if (skill.getSkillid() == Idfrom) {
                index = i;
                break;
            }
            ++i;
        }
        if (index == -1) {
            return -1;
        }
        if (this.hasAnyInternal(Idto)) {
            return -3;
        }
        PetSkill newSkill = Pod.newPetSkill();
        newSkill.setSkillid(Idto);
        newSkill.setSkilltype(1);
        PetSkill oldSkill = internals.set(index, newSkill);
        this.updatePetScoreWhileChange();
        this.updatePetInternalChange();
        return oldSkill.getSkillid();
    }
}

